-- create a database and user:
--   createuser heco
--   createdb -O heco heco
--   psql -c "ALTER USER heco PASSWORD 'heco';"
--   psql heco < contrib/postgresql.sql
BEGIN;

CREATE TABLE projects (
    id          int PRIMARY KEY GENERATED BY DEFAULT AS IDENTITY,
    key         VARCHAR(16) NOT NULL,
    description VARCHAR(256),
    active      BOOLEAN DEFAULT TRUE,
    UNIQUE(key)
);

CREATE TABLE entries (
    id          INTEGER PRIMARY KEY GENERATED BY DEFAULT AS IDENTITY,
    project_id  INTEGER REFERENCES projects(id),
    start_time  TIMESTAMP NOT NULL,
    stop_time   TIMESTAMP NOT NULL,
    description VARCHAR(256),

    CHECK (start_time <= stop_time)
);

CREATE TABLE recover (
    id          INTEGER PRIMARY KEY,
    project_id  INTEGER REFERENCES projects(id),
    start_time  TIMESTAMP NOT NULL,
    stop_time   TIMESTAMP NOT NULL,
    description VARCHAR(256),

    CHECK (start_time <= stop_time)
);

CREATE INDEX ON entries(project_id);

GRANT INSERT, DELETE, SELECT, UPDATE ON projects TO heco;
GRANT INSERT, DELETE, SELECT, UPDATE ON entries  TO heco;
GRANT INSERT, DELETE, SELECT, UPDATE ON recover  TO heco;

END;
